//-----------------------------------------------------------
//    cframe.cpp
//-----------------------------------------------------------
#include "cframe.h"
#include "knob.h"
//-----------------------------------------------------------
//    constructor
//-----------------------------------------------------------
cFrame::cFrame(wxWindow* parent, int id, const wxString& title, const wxPoint& pos, const wxSize& size, long style):
    wxFrame(parent, id, title, pos, size, wxDEFAULT_FRAME_STYLE)
{
	text_ctrl_1 = new wxTextCtrl(this, wxID_ANY);
	knob_1 = new Knob(this, wxID_ANY, 0.0, 0.0, 100.0, 60);
	Connect(myEVT_KNOB_UPDATED, wxCommandEventHandler(cFrame::OnKnob));
	set_properties();
	do_layout();
}

//-----------------------------------------------------------
//    destructor
//-----------------------------------------------------------
cFrame::~cFrame()
{
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void cFrame::set_properties()
{
	SetTitle(wxT("knob test"));
	SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_3DLIGHT));
}

//-----------------------------------------------------------
//    
//-----------------------------------------------------------
void cFrame::do_layout()
{
	wxBoxSizer* sizer_1 = new wxBoxSizer(wxVERTICAL);
	sizer_1->Add(text_ctrl_1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	sizer_1->Add(knob_1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(sizer_1);
	sizer_1->Fit(this);
	Layout();
}

void cFrame::OnKnob(wxCommandEvent& event)
{
	wxString str1 = wxString::Format(wxT("%f\n"), knob_1->GetValue());
	text_ctrl_1->Clear();
	text_ctrl_1->AppendText(str1);
}
